/// Get a result from an external source
pub trait Fetch<Q, R = Self> {
    fn fetch(query: Q) -> R;
}

/// Try to get a result from an external source
pub trait TryFetch<Q, R = Self> {
    type Error;
    fn try_fetch(query: Q) -> Result<R, Self::Error>;
}